From 8b7c60d9c93a84fec8f7db79a9ccbac2e36cc9fc Mon Sep 17 00:00:00 2001
From: Peter Geoghegan <pg@bowt.ie>
Date: Mon, 1 Jun 2026 19:35:47 -0400
Subject: [PATCH v30 05/12] WIP: Adopt amgetbatch interface in GiST index AM.

Replace gistgettuple with gistgetbatch, a function that implements the
new amgetbatch interface added by commit FIXME.  Plain index scans of
GiST indexes now return matching items in batches consisting of all of
the matches from a given leaf page.  This gives the table AM the ability
to perform optimizations like index prefetching during GiST index scans.

The amgetbatch interface requires that index AMs take the same
standardized approach to pin management for pins that are used to
prevent unsafe concurrent TID recycling by VACUUM (that way prefetching
can hold open multiple batches without it affecting the read stream).
For an ordinary GiST batch this interlock pin is the pin on its single
leaf page, held only for as long as the table AM still needs it as an
interlock (just like during nbtree and hash scans).

Nearest-neighbor (ordered) scans are handled quite differently, because
their matches don't naturally arrive one leaf page at a time.  Here
gistgetbatch instead drains the scan's distance-ordered pairing heap,
packing the matching leaf items into a single "virtual" batch in
distance order, typically spanning many leaf pages.  We're effectively
pretending that the matches we found were in useful order, together on
the same leaf page -- though that isn't really true.  Virtual batches
come with restrictions that make the pretense safe: an ordered scan is
never planned as an index-only scan, and gistkillitemsbatch does nothing
for a virtual batch.  A virtual batch therefore never holds a TID
recycling interlock pin at all; the pin on each underlying leaf page is
instead dropped right away, as the page is scanned into the queue.

The interlock pin also fixes a pre-existing bug in which GiST index-only
scans could return wrong answers [1].  An index-only scan trusts the
visibility map instead of fetching the heap tuple, so it must keep
VACUUM from recycling a heap TID between the moment it reads an index
entry and the moment it consults the visibility map; otherwise it can
report indexed values that belong to an unrelated, since-recycled heap
tuple.  The retained leaf-page buffer pin is that interlock -- but only
if VACUUM honors it.  gistvacuumpage therefore now acquires a cleanup
lock on each page (rather than a plain exclusive lock), so a concurrent
scan's pin holds VACUUM off from recycling that page's TIDs until the
scan has finished its visibility checks.

This same interlock requirement is why ordered scans cannot be
index-only: a virtual batch drops each leaf page's pin as soon as the
page is scanned, so it has no bounded pin to offer as the recycling
interlock that an index-only scan depends on.  Rather than work around
that (which seems prohibitively complicated), the planner never builds
an index-only scan that uses ordering operators; ordered scans must be
plain index scans, which fetch and recheck the heap tuple and so were
never subject to the bug.  This warrants an incompatibility item in the
Postgres 20 release notes (note that both GiST and SP-GiST are affected).

The gistgetbatch implementation makes use of new batch-related core
infrastructure.  GiST now registers an amgettransform callback, which
sets the scan descriptor's per-tuple recheck flags.  It also sets
order-by distances, and reconstructs a heap tuple for index-only scans.
It is called just before table_index_getnext_slot returns another tuple.
Like nbtree, the scan uses a currTuples storage area to store IndexTuple
structs in their original on-disk representation.  Unlike nbtree, GiST
uses amgettransform to convert the representation of the tuples into a
heap tuple representation of the underlying indexed type.  This scheme
also relies on a new facility that allows index AMs to request their own
separate dynamically sized area for supplemental metadata (GiST
opclasses have the ability to represent that any tuple needs a recheck,
so we have to shuttle that information around with the batch).

[1] https://postgr.es/m/CAH2-Wz=jjiNL9FCh8C1L-GUH15f4WFTWub2x+_NucngcDDcHKw@mail.gmail.com

Author: Peter Geoghegan <pg@bowt.ie>
---
 src/include/access/amapi.h                    |   5 +
 src/include/access/gist_private.h             |  76 +-
 src/include/access/gistxlog.h                 |  13 +-
 src/include/access/indexbatch.h               |  37 +-
 src/include/access/relscan.h                  |   5 +
 src/backend/access/brin/brin.c                |   1 +
 src/backend/access/gin/ginutil.c              |   1 +
 src/backend/access/gist/README                |  94 ++-
 src/backend/access/gist/gist.c                |  11 +-
 src/backend/access/gist/gistget.c             | 676 +++++++++++-------
 src/backend/access/gist/gistscan.c            |  50 +-
 src/backend/access/gist/gistutil.c            |   9 +-
 src/backend/access/gist/gistvacuum.c          |  18 +-
 src/backend/access/gist/gistxlog.c            |  22 +-
 src/backend/access/hash/hash.c                |   1 +
 src/backend/access/heap/heapam_indexscan.c    |  22 +-
 src/backend/access/index/amapi.c              |   1 +
 src/backend/access/index/genam.c              |   1 +
 src/backend/access/index/indexbatch.c         |   5 +-
 src/backend/access/nbtree/nbtree.c            |   1 +
 src/backend/access/rmgrdesc/gistdesc.c        |   4 +
 src/backend/access/spgist/spgutils.c          |   1 +
 src/backend/executor/nodeIndexonlyscan.c      |  12 -
 src/backend/optimizer/path/indxpath.c         |   5 +-
 contrib/bloom/blutils.c                       |   1 +
 contrib/btree_gist/expected/cash.out          |   6 +-
 contrib/btree_gist/expected/date.out          |   6 +-
 contrib/btree_gist/expected/float4.out        |   6 +-
 contrib/btree_gist/expected/float8.out        |   2 +-
 contrib/btree_gist/expected/int2.out          |   6 +-
 contrib/btree_gist/expected/int4.out          |   6 +-
 contrib/btree_gist/expected/int8.out          |   2 +-
 contrib/btree_gist/expected/interval.out      |   2 +-
 contrib/btree_gist/expected/time.out          |   2 +-
 contrib/btree_gist/expected/timestamp.out     |   2 +-
 contrib/btree_gist/expected/timestamptz.out   |   2 +-
 doc/src/sgml/indexam.sgml                     | 200 +++++-
 .../modules/dummy_index_am/dummy_index_am.c   |   1 +
 .../modules/index/expected/killtuples.out     |  77 ++
 src/test/modules/index/specs/killtuples.spec  |  15 +
 src/test/regress/expected/create_index.out    |  14 +-
 .../regress/expected/create_index_spgist.out  |  18 +-
 src/test/regress/expected/gist.out            |  52 +-
 src/test/regress/sql/gist.sql                 |   8 +-
 src/tools/pgindent/typedefs.list              |   2 +
 45 files changed, 1035 insertions(+), 466 deletions(-)

diff --git a/src/include/access/amapi.h b/src/include/access/amapi.h
index 02793a115..157c1a8df 100644
--- a/src/include/access/amapi.h
+++ b/src/include/access/amapi.h
@@ -212,6 +212,10 @@ typedef void (*amunguardbatch_function) (IndexScanDesc scan,
 typedef void (*amkillitemsbatch_function) (IndexScanDesc scan,
 										   IndexScanBatch batch);
 
+/* Set up the scan's xs_hitup output tuple for the given batch item */
+typedef void (*amgettransform_function) (IndexScanDesc scan,
+										 IndexScanBatch batch, int item);
+
 /* fetch all valid tuples */
 typedef int64 (*amgetbitmap_function) (IndexScanDesc scan,
 									   TIDBitmap *tbm);
@@ -326,6 +330,7 @@ typedef struct IndexAmRoutine
 	amgetbatch_function amgetbatch; /* can be NULL */
 	amunguardbatch_function amunguardbatch; /* can be NULL */
 	amkillitemsbatch_function amkillitemsbatch; /* can be NULL */
+	amgettransform_function amgettransform; /* can be NULL */
 	amgetbitmap_function amgetbitmap;	/* can be NULL */
 	amendscan_function amendscan;
 	amposreset_function amposreset; /* can be NULL */
diff --git a/src/include/access/gist_private.h b/src/include/access/gist_private.h
index 44514f1cb..f31aa7c9d 100644
--- a/src/include/access/gist_private.h
+++ b/src/include/access/gist_private.h
@@ -16,6 +16,7 @@
 
 #include "access/amapi.h"
 #include "access/gist.h"
+#include "access/indexbatch.h"
 #include "access/itup.h"
 #include "lib/pairingheap.h"
 #include "storage/bufmgr.h"
@@ -120,10 +121,6 @@ typedef struct GISTSearchHeapItem
 	ItemPointerData heapPtr;
 	bool		recheck;		/* T if quals must be rechecked */
 	bool		recheckDistances;	/* T if distances must be rechecked */
-	HeapTuple	recontup;		/* data reconstructed from the index, used in
-								 * index-only scans */
-	OffsetNumber offnum;		/* track offset in page to mark tuple as
-								 * LP_DEAD */
 } GISTSearchHeapItem;
 
 /* Unvisited item, either index page or heap tuple */
@@ -148,6 +145,55 @@ typedef struct GISTSearchItem
 	(offsetof(GISTSearchItem, distances) + \
 	 sizeof(IndexOrderByDistance) * (n_distances))
 
+/* Per-batch data private to the GiST index AM */
+typedef struct GISTBatchData
+{
+	/* leaf page's buffer pin */
+	Buffer		buf;
+	/* leaf page's block number (InvalidBlockNumber means "virtual" batch) */
+	BlockNumber blkno;
+} GISTBatchData;
+
+/* Access the GiST-private per-batch data from an IndexScanBatch pointer */
+#define GISTBatchGetData(scan, batch) \
+	index_scan_batch_index_opaque_static(scan, batch, GISTBatchData)
+
+/*
+ * Per-item private GiST data.  We lay out the index AM's dynamic opaque area
+ * as an array of these, one per batch item, and subscript it via
+ * GISTBatchGetItem.
+ *
+ * GiST matching is potentially lossy, and the Consistent function's recheck
+ * flag varies from one item to the next, so every batch item records its own
+ * qual recheck flag; gistgettransform reports it as the item's xs_recheck.
+ *
+ * Note: Unordered scans only need a recheck flag, so their dynamic opaque
+ * area is just a bool array, subscripted via GISTBatchGetRecheck.
+ */
+typedef struct GISTBatchItem
+{
+	bool		recheck;		/* T if quals must be rechecked */
+	bool		recheckDistances;	/* T if distances are lossy lower bounds */
+	/* numberOfOrderBys entries */
+	IndexOrderByDistance distances[FLEXIBLE_ARRAY_MEMBER];
+} GISTBatchItem;
+
+#define SizeOfGISTBatchItem(n_distances) \
+	(offsetof(GISTBatchItem, distances) + \
+	 sizeof(IndexOrderByDistance) * (n_distances))
+
+/* Get an item from dynamic area during an ordered scan */
+#define GISTBatchGetItem(scan, batch, item) \
+	(AssertMacro((scan)->numberOfOrderBys > 0), \
+	 AssertMacro((item) >= 0 && (item) < MaxIndexTuplesPerPage), \
+	 (GISTBatchItem *) ((char *) index_scan_batch_index_opaque_dyn((scan), (batch)) + \
+						(Size) (item) * SizeOfGISTBatchItem((scan)->numberOfOrderBys)))
+
+/* Get an item from dynamic area during a non-ordered scan */
+#define GISTBatchGetRecheck(scan, batch) \
+	(AssertMacro((scan)->numberOfOrderBys == 0), \
+	 (bool *) index_scan_batch_index_opaque_dyn((scan), (batch)))
+
 /*
  * GISTScanOpaqueData: private state for a scan of a GiST index
  */
@@ -159,23 +205,9 @@ typedef struct GISTScanOpaqueData
 	pairingheap *queue;			/* queue of unvisited items */
 	MemoryContext queueCxt;		/* context holding the queue */
 	bool		qual_ok;		/* false if qual can never be satisfied */
-	bool		firstCall;		/* true until first gistgettuple call */
 
 	/* pre-allocated workspace arrays */
 	IndexOrderByDistance *distances;	/* output area for gistindex_keytest */
-
-	/* info about killed items if any (killedItems is NULL if never used) */
-	OffsetNumber *killedItems;	/* offset numbers of killed items */
-	int			numKilled;		/* number of currently stored items */
-	BlockNumber curBlkno;		/* current number of block */
-	GistNSN		curPageLSN;		/* pos in the WAL stream when page was read */
-
-	/* In a non-ordered search, returnable heap items are stored here: */
-	GISTSearchHeapItem pageData[BLCKSZ / sizeof(IndexTupleData)];
-	OffsetNumber nPageData;		/* number of valid items in array */
-	OffsetNumber curPageData;	/* next item to return */
-	MemoryContext pageDataCxt;	/* context holding the fetched tuples, for
-								 * index-only scans */
 } GISTScanOpaqueData;
 
 typedef GISTScanOpaqueData *GISTScanOpaque;
@@ -446,7 +478,7 @@ extern void gistXLogPageReuse(Relation rel, Relation heaprel, BlockNumber blkno,
 extern XLogRecPtr gistXLogUpdate(Buffer buffer,
 								 OffsetNumber *todelete, int ntodelete,
 								 IndexTuple *itup, int ituplen,
-								 Buffer leftchildbuf);
+								 Buffer leftchildbuf, bool vacuum);
 
 extern XLogRecPtr gistXLogDelete(Buffer buffer, OffsetNumber *todelete,
 								 int ntodelete, TransactionId snapshotConflictHorizon,
@@ -458,7 +490,11 @@ extern XLogRecPtr gistXLogSplit(bool page_is_leaf,
 								Buffer leftchildbuf, bool markfollowright);
 
 /* gistget.c */
-extern bool gistgettuple(IndexScanDesc scan, ScanDirection dir);
+extern void gistkillitemsbatch(IndexScanDesc scan, IndexScanBatch batch);
+extern IndexScanBatch gistgetbatch(IndexScanDesc scan, IndexScanBatch priorbatch,
+								   ScanDirection dir);
+extern void gistunguardbatch(IndexScanDesc scan, IndexScanBatch batch);
+extern void gistgettransform(IndexScanDesc scan, IndexScanBatch batch, int item);
 extern int64 gistgetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
 extern bool gistcanreturn(Relation index, int attno);
 
diff --git a/src/include/access/gistxlog.h b/src/include/access/gistxlog.h
index 1c2cf6e81..86e5e1f86 100644
--- a/src/include/access/gistxlog.h
+++ b/src/include/access/gistxlog.h
@@ -18,17 +18,24 @@
 #include "lib/stringinfo.h"
 
 #define XLOG_GIST_PAGE_UPDATE		0x00
-#define XLOG_GIST_DELETE			0x10	/* delete leaf index tuples for a
-											 * page */
+#define XLOG_GIST_DELETE			0x10	/* delete leaf index tuples marked
+											 * as LP_DEAD during normal index
+											 * tuple insertion */
 #define XLOG_GIST_PAGE_REUSE		0x20	/* old page is about to be reused
 											 * from FSM */
 #define XLOG_GIST_PAGE_SPLIT		0x30
- /* #define XLOG_GIST_INSERT_COMPLETE	 0x40 */	/* not used anymore */
+#define XLOG_GIST_PAGE_VACUUM		0x40	/* delete leaf index tuples during
+											 * VACUUM */
  /* #define XLOG_GIST_CREATE_INDEX		 0x50 */	/* not used anymore */
 #define XLOG_GIST_PAGE_DELETE		0x60
  /* #define XLOG_GIST_ASSIGN_LSN		 0x70 */	/* not used anymore */
 
 /*
+ * Used by both XLOG_GIST_PAGE_UPDATE and XLOG_GIST_PAGE_VACUUM.  VACUUM only
+ * ever deletes tuples (ntoinsert is 0, and there is no left child), but the
+ * page-level changes are otherwise the same; the records differ only in that
+ * replaying a VACUUM record takes a cleanup lock on the target page.
+ *
  * Backup Blk 0: updated page.
  * Backup Blk 1: If this operation completes a page split, by inserting a
  *				 downlink for the split page, the left half of the split
diff --git a/src/include/access/indexbatch.h b/src/include/access/indexbatch.h
index bf0b68788..3393c4879 100644
--- a/src/include/access/indexbatch.h
+++ b/src/include/access/indexbatch.h
@@ -102,6 +102,8 @@ index_scan_batch_append(IndexScanDesc scan, IndexScanBatch batch)
  *
  *   [table AM opaque area]    <- table AM area (batch_table_opaque_size),
  *                                optionally requested by table AM
+ *   [index AM dyn opaque]     <- index AM area (batch_index_opaque_dyn),
+ *                                optionally requested by index AM
  *   [index AM static opaque]  <- index AM area (batch_index_opaque_static),
  *                                mandatory fixed-size index AM area
  *   [IndexScanBatchData]      <- batch pointer, returned by amgetbatch
@@ -109,12 +111,12 @@ index_scan_batch_append(IndexScanDesc scan, IndexScanBatch batch)
  *   [currTuples workspace]    <- index tuple area (batch_tuples_workspace),
  *                                only used during index-only scans
  *
- * batch_base_offset combines the table AM opaque area and the static index AM
- * opaque area into a single offset from the batch pointer to the true
- * allocation base.  We pfree a batch by passing pfree a pointer returned by
- * index_scan_batch_base.  We rely on the assumption that batches have a fixed
- * layout for the duration of an index scan (batches are cached for reuse to
- * avoid palloc churn).
+ * batch_base_offset combines the table AM opaque area, the optional dynamic
+ * index AM opaque area, and the static index AM opaque area into a single
+ * offset from the batch pointer to the true allocation base.  We pfree a
+ * batch by passing pfree a pointer returned by index_scan_batch_base.  We
+ * rely on the assumption that batches have a fixed layout for the duration of
+ * an index scan (batches are cached for reuse to avoid palloc churn).
  *
  * The table AM accesses its opaque area (sized batch_table_opaque_size) using
  * the index_scan_batch_table_area shim accessor.  The table AM's
@@ -130,6 +132,17 @@ index_scan_batch_append(IndexScanDesc scan, IndexScanBatch batch)
  * area.  Access to the area is cheap (a compile-time-constant subtraction),
  * but its size cannot vary from scan to scan.  Index AMs typically use this
  * area to store things like index page sibling link block numbers.
+ *
+ * Index AMs can use a second, optional dynamically-sized private area
+ * (batch_index_opaque_dyn) that sits just before the static area.  Its size
+ * is chosen at scan start rather than at compile time.  It is accessed via
+ * index_scan_batch_index_opaque_dyn.  This second area is generally only used
+ * during scans where large amounts of supplemental metadata are required,
+ * that cannot reasonably be allocated for every scan.  Typically, this is
+ * granular information about the batch's items for use by the index AM's
+ * amgettransform routine (the tuples themselves are stored separately, in
+ * on-disk format, in the currTuples workspace; amgettransform converts each
+ * one into the scan's returnable tuple).
  * ----------------------------------------------------------------------------
  */
 
@@ -166,6 +179,18 @@ index_scan_batch_table_area(IndexScanDesc scan, IndexScanBatch batch)
 	(AssertMacro((scan)->batch_index_opaque_static == MAXALIGN(sizeof(type))), \
 	 ((type *) ((char *) (batch) - MAXALIGN(sizeof(type)))))
 
+/*
+ * Return a pointer to the index AM's dynamic opaque area
+ */
+static inline void *
+index_scan_batch_index_opaque_dyn(IndexScanDesc scan, IndexScanBatch batch)
+{
+	Assert(scan->batch_index_opaque_dyn > 0);
+
+	return (char *) batch - scan->batch_index_opaque_static -
+		MAXALIGN(scan->batch_index_opaque_dyn);
+}
+
 /* ----------------------------------------------------------------------------
  * Elementary batch position operations
  * ----------------------------------------------------------------------------
diff --git a/src/include/access/relscan.h b/src/include/access/relscan.h
index d0b1cfa94..3d7093f99 100644
--- a/src/include/access/relscan.h
+++ b/src/include/access/relscan.h
@@ -369,6 +369,11 @@ typedef struct IndexScanDescData
 	 */
 	uint32		batch_table_opaque_size;	/* table AM opaque area size */
 
+	/*
+	 * Optional dynamic opaque size, also set by index AM in ambeginscan
+	 */
+	uint32		batch_index_opaque_dyn;
+
 	/*
 	 * Offset used by index_scan_batch_base (set on first batch alloc).  See
 	 * access/indexbatch.h.
diff --git a/src/backend/access/brin/brin.c b/src/backend/access/brin/brin.c
index 2d9d04aa3..4799a40b7 100644
--- a/src/backend/access/brin/brin.c
+++ b/src/backend/access/brin/brin.c
@@ -302,6 +302,7 @@ brinhandler(PG_FUNCTION_ARGS)
 		.amgetbatch = NULL,
 		.amunguardbatch = NULL,
 		.amkillitemsbatch = NULL,
+		.amgettransform = NULL,
 		.amgetbitmap = bringetbitmap,
 		.amendscan = brinendscan,
 		.amposreset = NULL,
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index 0e8b6a549..ceb9cb447 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -87,6 +87,7 @@ ginhandler(PG_FUNCTION_ARGS)
 		.amgetbatch = NULL,
 		.amunguardbatch = NULL,
 		.amkillitemsbatch = NULL,
+		.amgettransform = NULL,
 		.amgetbitmap = gingetbitmap,
 		.amendscan = ginendscan,
 		.amposreset = NULL,
diff --git a/src/backend/access/gist/README b/src/backend/access/gist/README
index 75445b074..8864a3faf 100644
--- a/src/backend/access/gist/README
+++ b/src/backend/access/gist/README
@@ -48,7 +48,7 @@ The original algorithms were modified in several ways:
 
 * They had to be adapted to PostgreSQL conventions. For example, the SEARCH
   algorithm was considerably changed, because in PostgreSQL the search function
-  should return one tuple (next), not all tuples at once. Also, it should
+  returns matching tuples incrementally, not all at once. Also, it should
   release page locks between calls.
 * Since we added support for variable length keys, it's not possible to
   guarantee enough free space for all keys on pages after splitting. User
@@ -71,20 +71,24 @@ was not touched in the paper.
 Search Algorithm
 ----------------
 
-The search code maintains a queue of unvisited items, where an "item" is
-either a heap tuple known to satisfy the search conditions, or an index
-page that is consistent with the search conditions according to inspection
-of its parent page's downlink item.  Initially the root page is searched
-to find unvisited items in it.  Then we pull items from the queue.  A
-heap tuple pointer is just returned immediately; an index page entry
-causes that page to be searched, generating more queue entries.
+The search code maintains a queue of unvisited items.  For a plain index
+scan an "item" is always an index page that is consistent with the search
+conditions according to inspection of its parent page's downlink item;
+matching heap tuples are not queued, but are gathered into a batch as each
+leaf page is scanned (see "Returning matches in batches", below).  For a
+nearest-neighbor (ordered) scan the queue additionally holds heap tuples
+known to satisfy the search conditions, so that heap tuples and index
+pages can be interleaved in distance order.  Initially the root page is
+added to the queue.  Then we pull items from the queue: an index page
+entry causes that page to be scanned, generating more queue entries, while
+a heap tuple entry (ordered scans only) is a match to be returned.
 
-The queue is kept ordered with heap tuple items at the front, then
-index page entries, with any newly-added index page entry inserted
-before existing index page entries.  This ensures depth-first traversal
-of the index, and in particular causes the first few heap tuples to be
-returned as soon as possible.  That is helpful in case there is a LIMIT
-that requires only a few tuples to be produced.
+The queue is kept ordered so that we perform a depth-first traversal of
+the index: any newly-added index page entry is inserted before existing
+index page entries, and (for ordered scans) heap tuple items are kept at
+the front.  This causes the first few matching heap tuples to be returned
+as soon as possible, which is helpful in case there is a LIMIT that
+requires only a few tuples to be produced.
 
 To implement nearest-neighbor search, the queue entries are augmented
 with distance data: heap tuple entries are labeled with exact distance
@@ -94,17 +98,18 @@ queue entries are retrieved in smallest-distance-first order, with
 entries having identical distances managed as stated in the previous
 paragraph.
 
-The search algorithm keeps an index page locked only long enough to scan
-its entries and queue those that satisfy the search conditions.  Since
-insertions can occur concurrently with searches, it is possible for an
-index child page to be split between the time we make a queue entry for it
-(while visiting its parent page) and the time we actually reach and scan
-the child page.  To avoid missing the entries that were moved to the right
-sibling, we detect whether a split has occurred by comparing the child
-page's NSN (node sequence number, a special-purpose LSN) to the LSN that
-the parent had when visited.  If it did, the sibling page is immediately
-added to the front of the queue, ensuring that its items will be scanned
-in the same order as if they were still on the original child page.
+The search algorithm keeps an index page locked only long enough to scan its
+entries -- queueing the child pages that satisfy the search conditions, and
+gathering any matching heap tuples (into a batch, or onto the queue for an
+ordered scan).  Since insertions can occur concurrently with searches, it is
+possible for an index child page to be split between the time we make a queue
+entry for it (while visiting its parent page) and the time we actually reach
+and scan the child page.  To avoid missing the entries that were moved to the
+right sibling, we detect whether a split has occurred by comparing the child
+page's NSN (node sequence number, a special-purpose LSN) to the LSN that the
+parent had when visited.  If it did, the sibling page is immediately added to
+the front of the queue, ensuring that its items will be scanned in the same
+order as if they were still on the original child page.
 
 As is usual in Postgres, the search algorithm only guarantees to find index
 entries that existed before the scan started; index entries added during
@@ -116,6 +121,36 @@ Any such enlargement would be to add child items that we aren't interested
 in returning anyway.
 
 
+Returning matches in batches
+----------------------------
+
+GiST implements the amgetbatch index AM interface, whose contract is
+documented in doc/src/sgml/indexam.sgml (see also
+src/backend/access/nbtree/README).  Each call hands the table AM a batch of
+matching TIDs rather than a single TID.  GiST forms two kinds of batch:
+
+* A plain (non-ordered) scan returns one "conventional" batch per leaf
+  page, holding all of that page's matching TIDs in physical order.  As in
+  nbtree and hash, the batch retains the leaf page's buffer pin (though not
+  its content lock) as the interlock against concurrent TID recycling by
+  VACUUM.
+
+* A nearest-neighbor (ordered) scan returns a single "virtual" batch.  Its
+  matches don't arrive one leaf page at a time, so instead we drain the
+  distance-ordered queue, copying matching TIDs into the batch in distance
+  order -- typically spanning many leaf pages.  A virtual batch retains no
+  buffer pin; each leaf page's pin is dropped as soon as the page is scanned.
+
+VACUUM honors a batch's pin by taking a cleanup lock on the leaf page (see
+"Bulk delete algorithm (VACUUM)", below), just as nbtree does.  Because a
+virtual batch holds no such pin, ordered scans come with two restrictions,
+both also seen in bitmap (amgetbitmap) scans and both explained in
+doc/src/sgml/indexam.sgml: they never set LP_DEAD bits (gistkillitemsbatch
+does nothing for a virtual batch), and they are never planned as index-only
+scans (a virtual batch has no pin to offer as the TID-recycling interlock
+that index-only scans depend on).
+
+
 Insert Algorithm
 ----------------
 
@@ -452,6 +487,15 @@ B-tree VACUUM uses, but because we already have NSNs on pages, to detect page
 splits during searches, we don't need a "vacuum cycle ID" concept for that
 like B-tree does.
 
+We take a full cleanup lock on every leaf page as we scan it, even leaf
+pages with no deletable tuples.  As in nbtree, this is the interlock that
+holds concurrent scans off from TID recycling; see "Returning matches in
+batches", above.  Replay of the resulting XLOG_GIST_PAGE_VACUUM records
+takes the same cleanup lock, so that the interlock also protects index-only
+scans running on a hot standby.  Recovery only needs the cleanup lock on
+pages that actually have items to delete (the only pages that generate a
+record), not on every leaf page.
+
 While we scan all the pages, we also make note of any completely empty leaf
 pages. We will try to unlink them from the tree after the scan. We also record
 the block numbers of all internal pages; they are needed to locate parents of
diff --git a/src/backend/access/gist/gist.c b/src/backend/access/gist/gist.c
index 67b16053a..47630b73e 100644
--- a/src/backend/access/gist/gist.c
+++ b/src/backend/access/gist/gist.c
@@ -103,10 +103,11 @@ gisthandler(PG_FUNCTION_ARGS)
 		.amadjustmembers = gistadjustmembers,
 		.ambeginscan = gistbeginscan,
 		.amrescan = gistrescan,
-		.amgettuple = gistgettuple,
-		.amgetbatch = NULL,
-		.amunguardbatch = NULL,
-		.amkillitemsbatch = NULL,
+		.amgettuple = NULL,
+		.amgetbatch = gistgetbatch,
+		.amunguardbatch = gistunguardbatch,
+		.amkillitemsbatch = gistkillitemsbatch,
+		.amgettransform = gistgettransform,
 		.amgetbitmap = gistgetbitmap,
 		.amendscan = gistendscan,
 		.amposreset = NULL,
@@ -594,7 +595,7 @@ gistplacetopage(Relation rel, Size freespace, GISTSTATE *giststate,
 
 				recptr = gistXLogUpdate(buffer,
 										deloffs, ndeloffs, itup, ntup,
-										leftchildbuf);
+										leftchildbuf, false);
 			}
 			else
 				recptr = XLogGetFakeLSN(rel);
